export declare enum RealmSyncServerOperatingMode {
    MasterWithNoSlave = 0,
    MasterWithAsynchronousSlave = 1,
    MasterWithSynchronousSlave = 2,
    Slave = 3,
}
export interface IRealmSyncServerConfiguration {
    dataPath: string;
    publicKeyPath: string;
    logCallback?: (level: number, message: string) => void;
    listenAddress?: string;
    listenPort?: string | number;
    reuseAddress?: boolean;
    statsEndpoint?: string;
    operatingMode?: RealmSyncServerOperatingMode;
    masterAddress?: string;
    masterPort?: string | number;
    masterSlaveSharedSecret?: string;
}
export interface IRealmSyncServerAddress {
    address: string;
    port: number;
}
export interface IRealmSyncServerBinding {
    new (config: any): any;
    start(callback: (err: any) => void): any;
    stop(callback: (err: any) => void): any;
    address(): any;
}
declare const RealmSyncServer_base: IRealmSyncServerBinding;
export declare class RealmSyncServer extends RealmSyncServer_base {
    constructor(config: IRealmSyncServerConfiguration);
    start(): Promise<void>;
    stop(): Promise<void>;
}
